package com.fp.persistence.pgeneral.acco;

import javax.persistence.Column;
import java.io.Serializable;
import com.fp.dto.hb.HibernateId;
import java.lang.reflect.Field;
import javax.persistence.Embeddable;
import javax.persistence.Transient;

/**Clase que hace referencia a la Clave Primaria de TGENETRANSACCOUNTSTATUS*/
@Embeddable
public class TgeneTransAccountStatusKey  extends com.fp.dto.AbstractDataTransport  implements Serializable,Cloneable,HibernateId{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
@Column(name="TRANSACTIONMODULE", nullable=false,updatable=false)

/**
* Modulo al que pertence la transaccion
*/
private String transactionmodule;

@Column(name="TRANSACTIONCODE", nullable=false,updatable=false)

/**
* Codigo de transaccion dentro del modulo
*/
private Integer transactioncode;

@Column(name="TRANSACTIONVERSION", nullable=false,updatable=false)

/**
* Version de transaccion
*/
private Integer transactionversion;

@Column(name="STATUSCODE", nullable=false,updatable=false)

/**
* Estatus de cuenta
*/
private String statuscode;

/**Contructor por defecto*/
public TgeneTransAccountStatusKey(){}
/**Contructor de TgeneTransAccountStatusKey
@param pTransactionmodule Modulo al que pertence la transaccion
@param pTransactioncode Codigo de transaccion dentro del modulo
@param pTransactionversion Version de transaccion
@param pStatuscode Estatus de cuenta
*/
public TgeneTransAccountStatusKey(String pTransactionmodule,Integer pTransactioncode,Integer pTransactionversion,String pStatuscode){
 transactionmodule=pTransactionmodule;
 transactioncode=pTransactioncode;
 transactionversion=pTransactionversion;
 statuscode=pStatuscode;
}
/**Obtiene el valor de transactionmodule
@return valor de transactionmodule*/
public String getTransactionmodule(){
  return transactionmodule;
}
/**Fija el valor de transactionmodule
@param pTransactionmodule nuevo Valor de transactionmodule*/
public void setTransactionmodule(String pTransactionmodule){
  transactionmodule=pTransactionmodule;
}

/**Obtiene el valor de transactioncode
@return valor de transactioncode*/
public Integer getTransactioncode(){
  return transactioncode;
}
/**Fija el valor de transactioncode
@param pTransactioncode nuevo Valor de transactioncode*/
public void setTransactioncode(Integer pTransactioncode){
  transactioncode=pTransactioncode;
}

/**Obtiene el valor de transactionversion
@return valor de transactionversion*/
public Integer getTransactionversion(){
  return transactionversion;
}
/**Fija el valor de transactionversion
@param pTransactionversion nuevo Valor de transactionversion*/
public void setTransactionversion(Integer pTransactionversion){
  transactionversion=pTransactionversion;
}

/**Obtiene el valor de statuscode
@return valor de statuscode*/
public String getStatuscode(){
  return statuscode;
}
/**Fija el valor de statuscode
@param pStatuscode nuevo Valor de statuscode*/
public void setStatuscode(String pStatuscode){
  statuscode=pStatuscode;
}

/**Implementación de la comparación de TgeneTransAccountStatusKey
@param o Objeto de comparación
*/
public boolean equals(Object o){
  if (o == null)return false;
  if (! (o instanceof TgeneTransAccountStatusKey))return false;
  TgeneTransAccountStatusKey that = (TgeneTransAccountStatusKey) o;
  if (this.getTransactionmodule() == null || that.getTransactionmodule() == null){
      return false;
  }
  if (! this.getTransactionmodule().equals(that.getTransactionmodule())){
    return false;
  }
  if (this.getTransactioncode() == null || that.getTransactioncode() == null){
      return false;
  }
  if (! this.getTransactioncode().equals(that.getTransactioncode())){
    return false;
  }
  if (this.getTransactionversion() == null || that.getTransactionversion() == null){
      return false;
  }
  if (! this.getTransactionversion().equals(that.getTransactionversion())){
    return false;
  }
  if (this.getStatuscode() == null || that.getStatuscode() == null){
      return false;
  }
  if (! this.getStatuscode().equals(that.getStatuscode())){
    return false;
  }
  return true;
}
/**Implementación del método hashCode bajo el patrón de Bloch
@return hashCode de la instancia TgeneTransAccountStatusKey
*/
public int hashCode(){
  if (this.hashValue == 0){
    int result = 17;
    result = result * 37 + (this.getTransactionmodule() == null ? 0 : this.getTransactionmodule().hashCode());
    result = result * 37 + (this.getTransactioncode() == null ? 0 : this.getTransactioncode().hashCode());
    result = result * 37 + (this.getTransactionversion() == null ? 0 : this.getTransactionversion().hashCode());
    result = result * 37 + (this.getStatuscode() == null ? 0 : this.getStatuscode().hashCode());
    this.hashValue = result;
  }
  return this.hashValue;
}
public Object cloneMe() throws CloneNotSupportedException {
  return this.clone();
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+="pk."+name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
}
